ClassicLevelUp = {}
local updateTimer;
local debugEnabled;

local stats = {
	[1] = {
		UnitHealthMax("player");
	},
	[2] = { 
		UnitPowerMax("player", SPELL_POWER_MANA);
	},
	[3] = {
		select(2, UnitStat("player", 1));
	},
	[4] = {
		select(2, UnitStat("player", 2));
	},
	[5] = {
		select(2, UnitStat("player", 3));
	},
	[6] = {
		select(2, UnitStat("player", 4));
	},
};

local currentStats = {
	[1] = {
		message = " hit points",
		api = function()
				  return UnitHealthMax("player");
			  end,
	},
	[2] = {
		message = " mana",
		api = function()
				  return UnitPowerMax("player", SPELL_POWER_MANA);
			  end,
	},
	[3] = {
		message = "Your Strength increases by ",
		api = function()
				  return select(2, UnitStat("player", 1));
			  end,
	},
	[4] = {
		message = "Your Agility increases by ",
		api = function()
				  return select(2, UnitStat("player", 2));
			  end,
	},
	[5] = {
		message = "Your Stamina increases by ",
		api = function()
				  return select(2, UnitStat("player", 3));
			  end,
	},
	[6] = {
		message = "Your Intellect increases by ",
		api = function()
				  return select(2, UnitStat("player", 4));
			  end,
	},
};

--Methods
ClassicLevelUp.UpdateStats = function(self)
	stats[1] = UnitHealthMax("player");
	stats[2] = UnitPowerMax("player", SPELL_POWER_MANA);
	stats[3] = select(2, UnitStat("player", 1));
	stats[4] = select(2, UnitStat("player", 2));
	stats[5] = select(2, UnitStat("player", 3));
	stats[6] = select(2, UnitStat("player", 4));
end

--Handlers--
function ClassicLevelUp.OnLoad(self)
	self:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
	self:RegisterEvent("PLAYER_LEVEL_UP");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_XP_UPDATE");
end

function ClassicLevelUp.OnEvent(self, event, ...)
	if ( event == "PLAYER_LEVEL_UP" ) then
		updateTimer = 0.100;
	end
	if (event == "PLAYER_EQUIPMENT_CHANGED" or event == "PLAYER_ENTERING_WORLD")  then
		ClassicLevelUp.UpdateStats();
		if (debugEnabled) then
			print("Updated Stats");
		end
	end
end

function ClassicLevelUp.OnUpdate(self, elapsed)

	if ( updateTimer ) then
		updateTimer = updateTimer - elapsed;
		if ( updateTimer <= 0.000 ) then
			updateTimer = nil;
			local i, statInfo, val;
			if (currentStats[2].api() - stats[2] > 0) then
				print("|cffffff00You have gained "..currentStats[1].api() - stats[1]..currentStats[1].message.." and "..currentStats[2].api() - stats[2]..currentStats[2].message..".");
			elseif (currentStats[1].api() - stats[1] > 0) then
				print("|cffffff00You have gained "..currentStats[1].api() - stats[1]..currentStats[1].message..".");
			end
				for i=3, #stats do
					statInfo = currentStats[i];
					val = statInfo.api() - stats[i];
				if (val > 0) then
					print("|cffffff00"..statInfo.message..val..".");
				end
			end
			ClassicLevelUp.UpdateStats();
		end
	end

end